<?php
defined('ABSPATH') || exit();
function fse_action($payment_id)
{
    $payment_meta = edd_get_payment_meta($payment_id);
    $mobile = $payment_meta['phone'];
    $p_user = fse_raedyArray(get_option('fse_p_user', ''), $payment_id, shortcode($payment_meta));
    $p_admin = fse_raedyArray(get_option('fse_p_admin', ''), $payment_id, shortcode($payment_meta));
    if (!is_null($p_user))
        fse_send(get_option('fse_api', ''), get_option('fse_sender', ''), $mobile, get_option('fse_pid_user', ''), $p_user);
    if (!is_null($p_admin))
        fse_send(get_option('fse_api', ''), get_option('fse_sender', ''), get_option('fse_admin_mobile', ''), get_option('fse_pid_admin', ''),
            $p_admin);
}

add_action('edd_complete_purchase', 'fse_action');

function fse_send($api, $sender, $mobile, $pid, $p)
{
    $str = '';
    $i = 1;
    foreach ($p as $item) {
        $key = $item['key'];
        $value = $item['value'];
        $str .= "&p$i=$key&v$i=$value";
        $i++;
    }
    if (empty($api)) return false;
    if (!extension_loaded('curl')) return false;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://ippanel.com:8080/?apikey=$api&pid=$pid&fnum=$sender&tnum=$mobile$str");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}

function fse_raedyArray($args, $payment_id, $payment_meta)
{
    $pattern = null;
    $i = 0;
    $args = trim($args);
    if (strpos($args, ',') !== false) {
        $args = explode(',', $args);
        foreach ($args as $arg) {
            $array = explode('=', trim($arg));
            if ($array[1] == 'payment_id') {
                $array[1] = $payment_id;
                $pattern[$i]['key'] = $array[0];
                $pattern[$i]['value'] = $array[1];
                $i++;
            } else if (isset($payment_meta[$array[1]])) {
                $array[1] = $payment_meta[$array[1]];
                $pattern[$i]['key'] = $array[0];
                $pattern[$i]['value'] = $array[1];
                $i++;
            }
        }
    } else {
        $array = explode('=', trim($args));
        if ($array[1] == 'payment_id') {
            $array[1] = $payment_id;
            $pattern[$i]['key'] = $array[0];
            $pattern[$i]['value'] = $array[1];
        } else if (isset($payment_meta[$array[1]])) {
            $array[1] = $payment_meta[$array[1]];
            $pattern[$i]['key'] = $array[0];
            $pattern[$i]['value'] = $array[1];
        }
    }

    return $pattern;
}

function shortcode($payment_meta)
{
    $result = null;
    $result['phone'] = $payment_meta['phone'];
    $result['email'] = $payment_meta['email'];
    $result['first_name'] = $payment_meta['user_info']['first_name'];
    $result['last_name'] = $payment_meta['user_info']['last_name'];

    for ($i = 0; $i < count($payment_meta['cart_details']); $i++) {
        if (isset($result['product']))
            $result['product'] .= ' - ' . $payment_meta['cart_details'][$i]['name'] . '(' . $payment_meta['cart_details'][$i]['quantity'] . ')';
        else $result['product'] .= $payment_meta['cart_details'][$i]['name'] . '(' . $payment_meta['cart_details'][$i]['quantity'] . ')';
        if (isset($result['price']))
            $result['price'] = intval($result['price']) + intval($payment_meta['cart_details'][$i]['subtotal']);
        else   $result['price'] = intval($payment_meta['cart_details'][$i]['subtotal']);
        if (isset($result['discount']))
            $result['discount'] = intval($result['discount']) + intval($payment_meta['cart_details'][$i]['discount']);
        else   $result['discount'] = intval($payment_meta['cart_details'][$i]['discount']);
        if (isset($result['total_price']))
            $result['total_price'] = intval($result['total_price']) + intval($payment_meta['cart_details'][$i]['price']);
        else  $result['total_price'] = intval($payment_meta['cart_details'][$i]['price']);
    }

    $result['price'] = number_format(intval($result['price']));
    $result['discount'] = number_format(intval($result['discount']));
    $result['total_price'] = number_format(intval($result['total_price']));

    return $result;
}

function sumobi_edd_display_checkout_fields()
{
    ?>
    <p id="edd-phone-wrap">
        <label class="edd-label" for="edd-phone">شماره موبایل</label>
        <span class="edd-description">
        	ما از این مورد برای ارسال اطلاعات سفارش استفاده می کنیم.
        </span>
        <input class="edd-input" type="text" name="edd_phone" id="edd-phone" placeholder="شماره موبایل"/>
    </p>
    <?php
}

add_action('edd_purchase_form_user_info_fields', 'sumobi_edd_display_checkout_fields', 1);

function sumobi_edd_store_custom_fields($payment_meta)
{

    if (0 !== did_action('edd_pre_process_purchase')) {
        $payment_meta['phone'] = isset($_POST['edd_phone']) ? sanitize_text_field($_POST['edd_phone']) : '';
    }

    return $payment_meta;
}

add_filter('edd_payment_meta', 'sumobi_edd_store_custom_fields');

function sumobi_edd_required_checkout_fields($required_fields)
{
    $required_fields['edd_phone'] = array(
        'error_id' => 'invalid_phone',
        'error_message' => 'یک شماره موبایل معتبر وارد کنید.'
    );


    return $required_fields;
}

add_filter('edd_purchase_form_required_fields', 'sumobi_edd_required_checkout_fields');
